/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

var widgetHeight = 0;

var defaultWidgetHeight = 0;
var defaultWidgetWidth = 0;

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
    
    // set up spinner
	$("#spinner").spinner({
		height: 16,
		width: 16,
		image: 'JQuery/spotlight_spinner_both.png'
	});
    
    // save the default height and width
    defaultWidgetHeight = window.innerHeight;
    defaultWidgetWidth = window.innerWidth;
    
    // set the default league preferences
	var league = widget.preferenceForKey(widget.identifier+"-league");
	if ( !(league && league.length > 0) ) {
        widget.setPreferenceForKey( "National League" , widget.identifier+"-league");
	}
    
    // set the default division preferences
	var division = widget.preferenceForKey(widget.identifier+"-division");
	if ( !(division && division.length > 0) ) {
        widget.setPreferenceForKey( "West" , widget.identifier+"-division");
	}
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
	checkForUpdates();
	setTimeout('refreshData();', 10);
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    // resize widget to the default size
    window.resizeTo(defaultWidgetWidth, defaultWidgetHeight);
    
    // perform the transition
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
    
    // update the UI
    updatePopUps();
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
    
    // reload the data
    setTimeout('refreshData();', 10);
    
    // resize widget
    window.resizeTo(defaultWidgetWidth, widgetHeight);
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

// ========================================
// Refresh Data
// ========================================

function refreshData()
{
    // start the spinner
	startSpinner();
	
	// get variables from preferences
	var division = widget.preferenceForKey(widget.identifier+"-division");
	var league = widget.preferenceForKey(widget.identifier+"-league").replace(" ", "");
	
	// get php path
	var phpPath = '/usr/bin/php';
	if( widget.preferenceForKey("phpPath") ) {
		phpPath = widget.preferenceForKey("phpPath");
    }
	
	// run php script
	var command = phpPath;
	command += " PHP/standings.php";
	command += " division=" + division;
	command += " league=" + league;
    
	widget.system(command, function(phpOutput) {
        
        // get script output
        var output;
        if( phpOutput.outputString ) {
            output = phpOutput.outputString;
        }
        
        // stop the spinner
        stopSpinner();
        
        // show output
        if( output ) {
            $('#outputBox').html( output );
        }
        
		// calculate resize values
        widgetHeight = $('#outputBox').children("table").height() + 35;
        
        // resize widget
		window.resizeTo(defaultWidgetWidth, widgetHeight);
    });
}

// ========================================
// Preferences
// ========================================

function openWebsite(event)
{
    widget.openURL("http://www.loganrockmore.com/MLBStandings/");
    return false;
}

function openDonationPage(event)
{
    widget.openURL("http://www.loganrockmore.com/MLBStandings/donate");
    return false;
}

function openReadMe(event)
{
    widget.system("/usr/bin/open ReadMe.rtf", null);
	return false;
}

function preferencesDidChange(event)
{
	var league = document.getElementById('leaguePopup').value;
	widget.setPreferenceForKey(league,widget.identifier+"-league");
    
	var division = document.getElementById('divisionPopup').value;
	widget.setPreferenceForKey(division,widget.identifier+"-division");
    
    // update the UI
    updatePopUps();
}


function updatePopUps()
{
	// update league
	var league = widget.preferenceForKey(widget.identifier+"-league");
	if (league && league.length > 0) {
		
		var leaguePopUp = document.getElementById('leaguePopup');
		for( i=0; i<leaguePopUp.length; i++) {
			var optionValue = leaguePopUp.options[i].value;
			if( optionValue == league )
				leaguePopUp.selectedIndex = i;
		}
	}
	
    // update division
	var division = widget.preferenceForKey(widget.identifier+"-division");
	if (division && division.length > 0) {
	
		var divisionPopUp = document.getElementById('divisionPopup');
		for( i=0; i<divisionPopUp.length; i++) {
			var optionValue = divisionPopUp.options[i].value;
			if( optionValue == division )
				divisionPopUp.selectedIndex = i;
		}
	}
}

// ========================================
// Spinner
// ========================================

function startSpinner()
{
	setTimeout("$.spinnerStart();",0);
	document.getElementById("spinner").style.display = "block";
}

function stopSpinner()
{
	document.getElementById("spinner").style.display = "none";
	setTimeout("$.spinnerStop();",0);
}
